This is an abstract class for platform specific filesystem implementations you have to implement each method in the platform specific filesystem implementation classes Your local filesytem implementation must extend this class.

You should also use this class as a template to write your local implementation Some native PHP filesystem specific methods are abstracted here as well. Anyway you must always use this methods via a PhingFile object (that by nature uses the *FileSystem drivers to access the real filesystem via this class using natives.

FIXME: - Error handling reduced to min fallthrough runtime exceptions more precise errorhandling is done by the PhingFile class

author | Charlie Killian
author | Hans Lellelid
version | $Id: bc979767c07b19eafeb3fc6f6efa938dd73bde18 $
package | phing.system.io

### Methods

## Whether file can be deleted.

    canDelete(\PhingFile $f) : boolean

### Parameters

#### $f

`\PhingFile`

### Returns

`boolean`

## canonicalize filename by checking on disk

    canonicalize(string $strPath) : mixed

### Parameters

#### $strPath

`string`

### Returns

`mixed`Canonical path or false if the file doesn't exist.

## Check whether the file or directory denoted by the given abstract pathname may be accessed by this process.

    checkAccess(\PhingFile $f, boolean $write)

If the second argument is false, then a check for read access is made; if the second argument is true, then a check for write (not read-write) access is made. Return false if access is denied or an I/O error occurs.

### Parameters

#### $f

`\PhingFile`

#### $write

`boolean`

## Change the group on a file or directory.

    chgrp(string $pathname, string $group) : void

### Parameters

#### $pathname

`string`

Path and name of file or directory.

#### $group

`string`

The group of the file or directory. See http://us.php.net/chgrp

### Exceptions

`\IOException` | if operation failed.

## Change the permissions on a file or directory.

    chmod(string $pathname, int $mode) : void

### Parameters

#### $pathname

`string`

Path and name of file or directory.

#### $mode

`int`

The mode (permissions) of the file or directory. If using octal add leading 0. eg. 0777. Mode is affected by the umask system setting.

### Exceptions

`\IOException` | if operation failed.

## Change the ownership on a file or directory.

    chown(string $pathname, string $user) : void

### Parameters

#### $pathname

`string`

Path and name of file or directory.

#### $user

`string`

The user name or number of the file or directory. See http://us.php.net/chown

### Exceptions

`\Exception` | if operation failed.

## Compare two abstract pathnames lexicographically.

    compare(\PhingFile $f1, \PhingFile $f2)

### Parameters

#### $f1

`\PhingFile`

#### $f2

`\PhingFile`

## Compare the modified time of two files.

    compareMTimes(\file1 $file1, \file2 $file2) : \Int.

### Parameters

#### $file1

`\file1`

String. Path and name of file1.

#### $file2

`\file2`

String. Path and name of file2.

### Exceptions

`\Exception` | - if cannot get modified time of either file.

### Returns

`\Int.`1 if file1 is newer. -1 if file2 is newer. 0 if files have the same time. Err object on failure.

## Copy a file.

    copy(\PhingFile $src, \PhingFile $dest) : void

### Parameters

#### $src

`\PhingFile`

Source path and name file to copy.

#### $dest

`\PhingFile`

Destination path and name of new file.

### Exceptions

`\IOException` | if file cannot be copied.

## Copy a file, or recursively copy a folder and its contents

    copyr(string $source, string $dest) : bool

author | Aidan Lister
version | 1.0.1
link | http://aidanlister.com/repos/v/function.copyr.php

### Parameters

#### $source

`string`

Source path

#### $dest

`string`

Destination path

### Returns

`bool`Returns TRUE on success, FALSE on failure

## Create a new directory denoted by the given abstract pathname, returning true if and only if the operation succeeds.

    createDirectory(\PhingFile $f, int $mode) : boolean

NOTE: umask() is reset to 0 while executing mkdir(), and restored afterwards

### Parameters

#### $f

`\PhingFile`

#### $mode

`int`

### Returns

`boolean`

## Create a new empty file with the given pathname.

    createNewFile(string $strPathname) : boolean

Return true if the file was created and false if a file or directory with the given pathname already exists. Throw an IOException if an I/O error occurs.

### Parameters

#### $strPathname

`string`

Path of the file to be created.

### Exceptions

`\IOException` |

### Returns

`boolean`

## Delete the file or directory denoted by the given abstract pathname, returning true if and only if the operation succeeds.

    delete(\PhingFile $f, boolean $recursive) : void

### Parameters

#### $f

`\PhingFile`

#### $recursive

`boolean`

## Arrange for the file or directory denoted by the given abstract pathname to be deleted when Phing::shutdown is called, returning true if and only if the operation succeeds.

    deleteOnExit(\PhingFile $f)

### Parameters

#### $f

`\PhingFile`

### Exceptions

`\IOException` |

## Post-process the given URI path string if necessary.

    fromURIPath(string $path)

This is used on win32, e.g., to transform "/c:/foo" into "c:/foo". The path string still has slash separators; code in the PhingFile class will translate them after this method returns.

### Parameters

#### $path

`string`

## Return the simple boolean attributes for the file or directory denoted by the given abstract pathname, or zero if it does not exist or some other I/O error occurs.

    getBooleanAttributes(\PhingFile $f)

### Parameters

#### $f

`\PhingFile`

## Return the parent pathname string to be used when the parent-directory argument in one of the two-argument PhingFile constructors is the empty pathname.

    getDefaultParent()

## Static method to return the FileSystem singelton representing this platform's local filesystem driver.

    getFileSystem() : \FileSystem

Static

### Exceptions

`\IOException` |

### Returns

`\FileSystem`

## Return the time at which the file or directory denoted by the given abstract pathname was last modified, or zero if it does not exist or some other I/O error occurs.

    getLastModifiedTime(\PhingFile $f) : int

### Parameters

#### $f

`\PhingFile`

### Exceptions

`\IOException` |

### Returns

`int`

## Return the length in bytes of the file denoted by the given abstract pathname, or zero if it does not exist, is a directory, or some other I/O error occurs.

    getLength(\PhingFile $f) : int

### Parameters

#### $f

`\PhingFile`

### Exceptions

`\IOException` |

### Returns

`int`

## Return the local filesystem's path-separator character.

    getPathSeparator()

## Return the local filesystem's name-separator character.

    getSeparator()

## Tell whether or not the given abstract pathname is absolute.

    isAbsolute(\PhingFile $f)

### Parameters

#### $f

`\PhingFile`

## List the elements of the directory denoted by the given abstract pathname.

    listDir(\PhingFile $f)

Return an array of strings naming the elements of the directory if successful; otherwise, return

    null

.

### Parameters

#### $f

`\PhingFile`

## List the available filesystem roots, return array of PhingFile objects

    listRoots()

### Exceptions

`\IOException` |

## Locks a file and throws an Exception if this is not possible.

    lock(\PhingFile $f) : void

### Parameters

#### $f

`\PhingFile`

### Exceptions

`\Exception` |

## Convert the given pathname string to normal form.

    normalize(string $strPath)

If the string is already in normal form then it is simply returned.

### Parameters

#### $strPath

`string`

## Compute the length of this pathname string's prefix.

    prefixLength(string $pathname)

The pathname string must be in normal form.

### Parameters

#### $pathname

`string`

## Rename the file or directory denoted by the first abstract pathname to the second abstract pathname, returning true if and only if the operation succeeds.

    rename(\PhingFile $f1, \PhingFile $f2) : void

### Parameters

#### $f1

`\PhingFile`

abstract source file

#### $f2

`\PhingFile`

abstract destination file

### Exceptions

`\IOException` | if rename cannot be performed

## Resolve the child pathname string against the parent.

    resolve(string $parent, string $child)

Both strings must be in normal form, and the result will be a string in normal form.

### Parameters

#### $parent

`string`

#### $child

`string`

## Resolve the given abstract pathname into absolute form.

    resolveFile(\PhingFile $f)

Invoked by the getAbsolutePath and getCanonicalPath methods in the PhingFile class.

### Parameters

#### $f

`\PhingFile`

## Delete an empty directory OR a directory and all of its contents.

    rmdir(\dir $dir, \children $children) : void

### Parameters

#### $dir

`\dir`

String. Path and/or name of directory to delete.

#### $children

`\children`

Boolean. False: don't delete directory contents. True: delete directory contents.

## Set the last-modified time of the file or directory denoted by the given abstract pathname returning true if and only if the operation succeeds.

    setLastModifiedTime(\PhingFile $f, int $time) : void

### Parameters

#### $f

`\PhingFile`

#### $time

`int`

### Exceptions

`\IOException` |

## Mark the file or directory denoted by the given abstract pathname as read-only, returning <code>true</code> if and only if the operation succeeds.

    setReadOnly(\PhingFile $f)

### Parameters

#### $f

`\PhingFile`

### Exceptions

`\IOException` |

## Symbolically link a file to another name.

    symlink(string $target, string $link) : void

Currently symlink is not implemented on Windows. Don't use if the application is to be portable.

### Parameters

#### $target

`string`

Path and/or name of file to link.

#### $link

`string`

Path and/or name of link to be created.

## Set the modification and access time on a file to the present time.

    touch(string $file, int $time) : void

### Parameters

#### $file

`string`

Path and/or name of file to touch.

#### $time

`int`

## Set the umask for file and directory creation.

    umask(\mode $mode) : void

### Parameters

#### $mode

`\mode`

Int. Permissions ususally in ocatal. Use leading 0 for octal. Number between 0 and 0777.

### Exceptions

`\Exception` | if there is an error performing operation.

## Delete a file.

    unlink(string $file) : void

### Parameters

#### $file

`string`

Path and/or name of file to delete.

### Exceptions

`\IOException` | - if an error is encountered.

## Unlocks a file and throws an IO Error if this is not possible.

    unlock(\PhingFile $f) : void

### Parameters

#### $f

`\PhingFile`

### Exceptions

`\IOException` |

### Properties

##

    $fs : \FileSystem

### Constants

## BA_DIRECTORY

    BA_DIRECTORY : int

## BA_EXISTS

    BA_EXISTS : int

## BA_HIDDEN

    BA_HIDDEN : int

## BA_REGULAR

    BA_REGULAR : int